#!/usr/bin/perl -w

# Copyright (C) 2000 Julian T. J. Midgley <jtjm@xenoclast.org>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# A copy of version 2 of the GNU General Public License may be found
# in the file "LICENCE" in the original Agnostos installation driectory.

use taskman_lib;
use strict;
use CGI;

my $dbh = dbserver_connect("agnostos");
my $query = new CGI;
my $table = $query -> param('table');
my ($idname, $entname) = get_table($table);
my ($dbq, %entries, $tmpid, $tmpname, $ent, @ents, @operable, $opid, $newvalue);

# Select existing entries

$dbq = $dbh -> prepare("select $idname, $entname from $table");
$dbq -> execute;
while (($tmpid, $tmpname) = $dbq -> fetchrow_array) {
    $entries{$tmpid} = $tmpname;
}
$dbq -> finish;

# Compare new entries with the old ones, and update any that have changed.

print $query -> header();
print "\n<html><head><meta http-equiv=Refresh content=\"1; URL=name_manage.pl?table=$table\">".
      "<title>Updating $table"."s</title></head><body bgcolor=white>\n";


@ents = $query -> param();

foreach $ent (@ents) {
    if ( $ent =~ /^entname_/ ) {
	push (@operable, $ent);
    }
}

foreach $ent (@operable) {
    $opid = $ent;
    $opid =~ s/^entname_//;
    $newvalue = $query -> param("$ent");
    unless ( $entries{$opid} eq $newvalue ) {
	Do_SQL_Query($dbh,"update $table set $entname='$newvalue' where $idname=$opid");
	print "Changed $entries{$opid} to $newvalue<br>\n";
    }
}

$dbh -> disconnect;
print html_footer();

